import java.util.Vector;


public class Student extends Osoba
{
	/*
	wymagane do serializacji, w przyszlosci jak cos zmienisz w tej klasie [dodasz/usuniesz atrybut]
	to zmienisz ta liczbe na inna, dzieki temu mechanizm 'serialize' nie pozwoli zaladowac 
	pliku z dysku z starymi danymi do programu ktory uzywa innej klasy
	(przeciez moze byc zupelnie inna klasa o nazwie Student i dane takie jak 'oceny' moga w niej
	nie wystepowac)
	 */
	private static final long serialVersionUID = 1L;
	
	// atrybut prosty, powtarzalny, obiektu
	private Vector<Double> oceny = new Vector<Double>();
	/*
	 * POWTARZALNY:
	 * obiekt zawiera 0 lub wiecej takich 'elementow'
	 * technicznie: lista/tablica
	 */
	
	Student(String imieOsoby, int wzrostOsoby)
	{
		/*
		 * 'super', bo dziedziczy po klasie ktora dziedziczy po ObjectPlus
		 * z parametrem 'imieOsoby' i 'wzrostOsoby', bo takie atrybuty sa wymagana w Osoba
		 */
		super(imieOsoby, wzrostOsoby);
	}
	
	/*
	 * PRZESLANIANIE METOD:
	 * w nadklasie Osoba metoda ta zwraca tylko imie,
	 * a w Student imie z dodanym na poczatku tekstem 'Student'
	 * jaki tego sens? trudno mi wymyslic jakas sensowna przeslaniana funkcje
	 * 
	 * technicznie: w klasie dziedziczacej jest metoda o takiej samej nazwie, takich samych argumentach,
	 * ale zwraca cos innego
	 */
	public String getImie()
	{
		return "Student " + this.imie;
	}
	
	/*
	 * PRZECIAZANIE METOD:
	 * metody maja taka sama nazwe, ale przyjmuja rozne parametry
	 * w tym przypadku jedna 'Double', a druga 'int'
	 */
	public void dodajOcene(Double ocena) throws Exception
	{
		if(ocena == null || ocena < 2 || ocena > 5)
		{
			throw new Exception("Ocena musi byc pomiedzy 2, a 5");
		}
		oceny.add(ocena);
	}
	public void dodajOcene(int ocena) throws Exception
	{
		if(ocena < 2 || ocena > 5)
		{
			throw new Exception("Ocena musi byc pomiedzy 2, a 5");
		}
		oceny.add(new Double(ocena));
	}
	
	public String toString()
	{
		// na poczatek opisu studenta wklejamy opis z Osoby (imie, nazwisko..) wywolujac metode z klasy 
		// z ktorej dziedziczymy, robimy to uzywajac 'super'
		String ret = super.toString();
		ret += "\nOceny: ";
		if(oceny.size() > 0)
		{
			for(Double ocena : oceny)
			{
				ret += ocena + ",";
			}
		}
		else
		{
			ret += "brak ocen";
		}
		return ret;
	}
}
